#define VERSION "1.0"

#include <stdio.h>
#include <syslog.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <netdb.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <stdarg.h>
#include <assert.h>
#include <sys/param.h>
#include <sys/types.h>
#ifndef _LINUX_C_LIB_VERSION
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#endif
#include <arpa/inet.h>

#include "kalasag_config.h"
#include "kalasag_io.h"
#include "kalasag_util.h"

#ifdef SUPPORT_STEALTH
#ifdef LINUX
#include "kalasag_tcpip.h"
#include <netinet/in_systm.h>
#endif

#define TCPPACKETLEN 80
#define UDPPACKETLEN 68
#endif				/* SUPPORT_STEALTH */

#ifdef NEXT
#include <ansi.h>
#endif

#define ERROR -1
#define TRUE 1
#define FALSE 0
#define MAXBUF 1024
/* max size of an IP address plus NULL */
#define IPMAXBUF 16
/* max sockets we can open */
#define MAXSOCKS 64

/* Really is about 1025, but we don't need the length for our purposes */
#define DNSMAXBUF 255


/* prototypes */
int KalasagModeTCP(void);
int KalasagModeUDP(void);
int DisposeUDP(char *, int);
int DisposeTCP(char *, int);
int CheckStateEngine(char *);
int InitConfig(void);
void Usage(void);
int SmartVerifyTCP(struct sockaddr_in, struct sockaddr_in, int);
int SmartVerifyUDP(struct sockaddr_in, struct sockaddr_in, int);

#ifdef SUPPORT_STEALTH
int KalasagStealthModeTCP(void);
int KalasagAdvancedStealthModeTCP(void);
int KalasagStealthModeUDP(void);
int KalasagAdvancedStealthModeUDP(void);
char *ReportPacketType(struct tcphdr);
int PacketReadTCP(int, struct iphdr *, struct tcphdr *);
int PacketReadUDP(int, struct iphdr *, struct udphdr *);
#endif
